POJ3026(BFS + prim)

Borg Maze

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 10554   Accepted: 3501

Description

The Borg is an immensely powerful race of enhanced humanoids from the delta quadrant of the galaxy. The Borg collective is the term used to describe the group consciousness of the Borg civilization. Each Borg individual is linked to the collective by a sophisticated subspace network that insures each member is given constant supervision and guidance.

Your task is to help the Borg (yes, really) by developing a program which helps the Borg to estimate the minimal cost of scanning a maze for the assimilation of aliens hiding in the maze, by moving in north, west, east, and south steps. The tricky thing is that the beginning of the search is conducted by a large group of over 100 individuals. Whenever an alien is assimilated, or at the beginning of the search, the group may split in two or more groups (but their consciousness is still collective.). The cost of searching a maze is definied as the total distance covered by all the groups involved in the search together. That is, if the original group walks five steps, then splits into two groups each walking three steps, the total distance is 11=5+3+3.

Input

On the first line of input there is one integer, N <= 50, giving the number of test cases in the input. Each test case starts with a line containg two integers x, y such that 1 <= x,y <= 50. After this, y lines follow, each which x characters. For each character, a space `` ‘‘ stands for an open space, a hash mark ``#‘‘ stands for an obstructing wall, the capital letter ``A‘‘ stand for an alien, and the capital letter ``S‘‘ stands for the start of the search. The perimeter of the maze is always closed, i.e., there is no way to get out from the coordinate of the ``S‘‘. At most 100 aliens are present in the maze, and everyone is reachable.

Output

For every test case, output one line containing the minimal cost of a succesful search of the maze leaving no aliens alive.

Sample Input

2
6 5
#####
#A#A##
# # A#
#S  ##
#####
7 7
#####
#AAA###
#    A#
# S ###
#     #
#AAA###
#####

Sample Output

8
11题意:求每个字母彼此之间的距离,找到一条最短路径将所有字母相连。思路:用BFS枚举每个字母之间的距离,再用prim求出最短的一条路径。收获:了解了prim要初始化和1相连的边权。这题还要再做一遍。
#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <string>
#include <cstring>
#include <stack>
#include <queue>
#include <list>
#include <vector>
#include <map>
#include <set>
using namespace std;

const int INF=0x3f3f3f3f;
const double eps=1e-10;
const double PI=acos(-1.0);
#define maxn 1000
struct Node
{
    int x, y, dis;
};
Node st, et;
int vis[maxn][maxn];
char map1[maxn][maxn];
int vis2[maxn];
int node[maxn][maxn];
int edge[maxn][maxn];
int dis[maxn];
int pre[maxn];
int dx[] = {0, 0, -1, 1};
int dy[] = {1, -1, 0 ,0};
int sum, n, m;
void bfs(int i, int j)
{
    memset(vis, 0, sizeof vis);
    queue<Node> q;
    Node st = {i, j, 0};
    vis[i][j] = 1;
    q.push(st);
    while(!q.empty())
    {
        Node t = q.front();
        q.pop();
        if(node[t.x][t.y])
            edge[node[st.x][st.y]][node[t.x][t.y]] = t.dis;
        for(int i = 0; i < 4; i++)
        {
            int x0 = t.x + dx[i];
            int y0 = t.y + dy[i];
            if(!vis[x0][y0] && map1[x0][y0] != ‘#‘ && x0>=0 && x0 < m && y0 >= 0 && y0 < n)
            {
                vis[x0][y0] = 1;
                Node f = {x0,  y0, t.dis+1};
                q.push(f);
            }
        }
    }

}
int low[maxn];
int Prim()
{
    int s=1,i,count=1,prim_sum=0,t;
    bool flag[maxn]={false};
    flag[s] = true;
    for(i=1; i<=sum; i++)
        low[i] = 99999;
    while(count < sum)
    {
        int min_dis = 99999;
        for(i=1; i<=sum; i++)
        {
            if(!flag[i] && low[i]>edge[s][i])
                low[i] = edge[s][i];
            if(!flag[i] && low[i]<min_dis)
            {
                min_dis = low[i];
                t = i;
            }
        }
        s = t; count++;
        flag[s] = true;
        prim_sum += min_dis;
    }
    return prim_sum;
}

int main()
{
    int t;
    scanf("%d", &t);
    while(t--)
    {
        scanf("%d%d", &n, &m);
        char temp[50];
        gets(temp);
        sum = 0;
        memset(node, 0, sizeof node);
        memset(edge, 0, sizeof edge);
        for(int i = 0; i < m; i++)
        {
            gets(map1[i]);
            for(int j = 0; j < n; j++)
            {
                if(map1[i][j] == ‘S‘ || map1[i][j] == ‘A‘)
                    node[i][j] = ++sum;
            }
        }
        for(int i = 0; i < m; i++)
            for(int j = 0; j < n; j++)
                if(node[i][j])
                bfs(i, j);
         printf("%d\n", Prim());
    }
    return 0;
}
时间: 2024-10-07 06:14:32

POJ3026(BFS + prim)的相关文章

poj3026(bfs+prim)

The Borg is an immensely powerful race of enhanced humanoids from the delta quadrant of the galaxy. The Borg collective is the term used to describe the group consciousness of the Borg civilization. Each Borg individual is linked to the collective by

POJ 3026(BFS+prim)

http://poj.org/problem?id=3026 题意:任意两个字母可以连线,求把所有字母串联起来和最小. 很明显这就是一个最小生成树,不过这个题有毒.他的输入有问题.在输入m和N后面,可能有一大串的空格.就因为这个,我RE都有点懵了,要不是discuss里面有人说输入有问题,我都没注意到这个,原本只用了一个getchar吃掉最后的换行符.没想到之后还有空格.有点小坑. 思路:这个题目如果他给你一个图,那就是最裸的prim了.不过这个题的难点也就是在他给的图你不能用Prim,你只能通

J - Borg Maze - poj 3026(BFS+prim)

在一个迷宫里面需要把一些字母.也就是 ‘A’ 和 ‘B’连接起来,求出来最短的连接方式需要多长,也就是最小生成树,地图需要预处理一下,用BFS先求出来两点间的最短距离, ********************************************************************************** #include<algorithm>#include<stdio.h>#include<string.h>#include<que

POJ3026 Borg Maze(Prim)(BFS)

Borg Maze Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 12729   Accepted: 4153 Description The Borg is an immensely powerful race of enhanced humanoids from the delta quadrant of the galaxy. The Borg collective is the term used to desc

poj3026Borg Maze(bfs预处理+最小生成树)

题目链接: 啊哈哈,点我点我 思路: 首先把图中的A S预处理出来,然后对这些点逐一做bfs找到这些点到其它点的最短路径,然后建图完毕也用最小生成树的prim算法或者kruscal算法求出连接所有点的最短距离..不知道为嘛用dis数组去维护为什么会超时,而在结构体里面用step数组却可以过,我也不知道为什么,纠结了很多天..我把错误的代码贴出来,希望各位帮我找出原因,不胜感激... 题目: Borg Maze Time Limit: 1000MS   Memory Limit: 65536K T

pots(BFS)

D - Pots Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%lld & %llu Submit Status Description You are given two pots, having the volume of A and B liters respectively. The following operations can be performed: Input On the first and

USACO抓牛catchcow (bfs)

这题是黄巨大出的比赛题. http://poj.org/problem?id=3278 Description Farmer John has been informed of the location of a fugitive cow and wants to catch her immediately. He starts at a point N (0 ≤ N ≤ 100,000) on a number line and the cow is at a point K (0 ≤ K ≤

hdu 3345 War Chess (bfs+优先队列)

War Chess Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1732    Accepted Submission(s): 416 Problem Description War chess is hh's favorite game: In this game, there is an N * M battle map, an

hdu 1728 逃离迷宫 (BFS)

逃离迷宫 Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 14376    Accepted Submission(s): 3458 Problem Description 给定一个m × n (m行, n列)的迷宫,迷宫中有两个位置,gloria想从迷宫的一个位置走到另外一个位置,当然迷宫中有些地方是空地,gloria可以穿越,有些地方